/*
**
****************************************************************************
**
**
**		Copyright (c) 2004/2005 - Atmel Corporation
**		L
**
** 		: AVR LIN
** 		: lin_bdr.h
** 		: LINްڰ ͯ ̧
**
** : t:	  : :
** 1.0 5.1.2005   E.G.  쐬
** 1.1 7.4.2005   E.G.
**
**  -
**
** ATMEL - 2004/2005
** SĂ̿ĳ ۸т͂ǂȎނ̕ۏ؂Ȃ"󂻂̂"Œ񋟂܂B
** ATMEL͂ǂȖړIɑ΂Ă񋟂fނ̓K۔F܂BATMEL͑SĂ̈
** ٓIȕۏ؁AړIւ̓KALA@܂݁A񋟂ĳɊ֘A
** SĂ̕ۏ؂ƏŔ۔F܂B̿ĳ ۸т̎gp̌ʂł
** ĂAǂȊԐړIApIȑQA܂͂ǂȑQɑ΂ĂAƂɂ
** SATMELɐӔCȂł傤B
****************************************************************************
**
*/

#ifndef _LIN_BDR_H_
#define _LIN_BDR_H_

/*_____ ݸٰ ̧ ________________________________________________________*/

/*_____ 萔` ____________________________________________________________*/
/**
* TIMEOUT_HEADER35ޯ+40%
*
*/

#ifndef LIN_CONFIG
#error You must define LIN_CONFIG (0 for master, 1 for slave) in config.h
#endif

#ifndef LIN_BAUDRATE
#error You must define LIN_BAUDRATE (2400/480/9600/19200)  in config.h
#endif

#ifndef FOSC
#error You must define FOSC in config.h

#elif FOSC == 8000
#if LIN_BAUDRATE == 19200
#if LIN_CONFIG == 1							// 1:]u, 0:呕u
#define UART_BAUDRATE_SYNC (32)				// fo
#endif

#if LIN_CONFIG == 0							// 1:]u, 0:呕u
#define UART_BAUDRATE_SYNC (37)				// f
#endif

#define UART_BAUDRATE_NORM			(25)
#define UART_BAUDRATE_SYNC_MASTER	(37)	// f(13ޯĎ)
#define TIMEOUT_M_HEADER			(0xAF)
#define TIMEOUT_S_HEADER			(0xB9)
#define TIMEOUT_RESPONSE_2DATA		(0xBA)
#define TIMEOUT_RESPONSE_4DATA		(0x8D)
#define TIMEOUT_RESPONSE_8DATA		(0x31)
#define TIMER_2_PRESCALER			(256)

#elif LIN_BAUDRATE == 9600
#if LIN_CONFIG == 1							// 1:]u, 0:呕u
#define UART_BAUDRATE_SYNC			(66)	// fo
#endif

#if LIN_CONFIG == 0							// 1:]u, 0:呕u
#define UART_BAUDRATE_SYNC			(75)	// f
#endif

#define UART_BAUDRATE_NORM			(51)
#define UART_BAUDRATE_SYNC_MASTER	(75)	// f(13ޯĎ)
#define TIMEOUT_M_HEADER			(213)
#define TIMEOUT_S_HEADER			(211)
#define TIMEOUT_RESPONSE_2DATA		(220)
#define TIMEOUT_RESPONSE_4DATA		(197)
#define TIMEOUT_RESPONSE_8DATA		(151)
#define TIMER_2_PRESCALER			(1024)
#elif LIN_BAUDRATE == 4800
#error " GIVEN LIN BAUDRATE IS NOT SUPPORTED (CONFIG.H) "
#elif LIN_BAUDRATE == 2400

#if LIN_CONFIG == 1							// 1:]u, 0:呕u
#define UART_BAUDRATE_SYNC			(269)	// fo
#endif

#if LIN_CONFIG == 0							// 1:]u, 0:呕u
#define UART_BAUDRATE_SYNC			(300)	// f
#endif

#define UART_BAUDRATE_NORM			(207)
#define UART_BAUDRATE_SYNC_MASTER	(300)	// f(13ޯĎ)
#define TIMEOUT_M_HEADER			(97)
#define TIMEOUT_S_HEADER			(125)
#define TIMEOUT_RESPONSE_2DATA		(117)
#define TIMEOUT_RESPONSE_4DATA		(26)
#define TIMEOUT_RESPONSE_8DATA		(99)	// 
#define TIMER_2_PRESCALER			(1024)
#else
#error " GIVEN LIN BAUDRATE IS NOT SUPPORTED (CONFIG.H) "
#endif

#else
#error no values are entered for this frequency in the  $RCSfile: lin_bdr.h,v $
#endif

#endif /* _LIN_BDR_H_ */
