/*
**
****************************************************************************
**
**
**		Copyright (c) 2004/2005 - Atmel Corporation
**		L
**
** 		: AVR LIN
** 		: lin_lib.h
** 		: LIN1.3Ő (ײ)
** ړIΏ	: AVRs
** ߲	: IAR Embedded Workbench 4.1
**
** : t:	  : :
** 1.0 5.1.2005   E.G.  쐬
**
**  -
**
** ATMEL - 2004/2005
** SĂ̿ĳ ۸т͂ǂȎނ̕ۏ؂Ȃ"󂻂̂"Œ񋟂܂B
** ATMEL͂ǂȖړIɑ΂Ă񋟂fނ̓K۔F܂BATMEL͑SĂ̈
** ٓIȕۏ؁AړIւ̓KALA@܂݁A񋟂ĳɊ֘A
** SĂ̕ۏ؂ƏŔ۔F܂B̿ĳ ۸т̎gp̌ʂł
** ĂAǂȊԐړIApIȑQA܂͂ǂȑQɑ΂ĂAƂɂ
** SATMELɐӔCȂł傤B
****************************************************************************
**
*/

#ifndef _LIN_LIB_H_
#define _LIN_LIB_H_

/*_____ ݸٰ ̧ ________________________________________________________*/
#include "config.h"
#include "lib_mcu/lin_uart/lin_drv_usart.h"
#include "lib_mcu/lin_uart/runtime_calibration_lib.h"

#if LIN_CONFIG == 1				// 1:]u, 0:呕u
#include "lib_mcu/lin_uart/slave_lin.h"
#else
#include "lib_mcu/lin_uart/master_lin.h"
#endif

/*_____ 萔` ____________________________________________________________*/
#define LIN_CMD_REFUSED		0		// 
#define LIN_CMD_ACCEPTED	1		// 󂯓

// "_lin_status"ϐpޯĒ`
#define LIN_STATUS_RX		0x01	// ްM튮׸
#define LIN_STATUS_TX		0x02	// ްM튮׸
#define LIN_STATUS_ID		0x04	// ʎq튮׸
#define LIN_STATUS_ERR		0x08	// ُ픭׸
#define LIN_STATUS_BUSY		0x10	// Z׸

/*_____ ^錾 _______________________________________________________________*/
/**
* @brief ̗񋓂st_cmd_lin_t\̂̎wүސ錾ɑ΂銈ÎɎgp܂B
**/
typedef enum {
  LIN_CMD_M_NONE,				// ߂Ȃ
  LIN_CMD_M_TX,					// 呕uM(ڰѐ擪+)
  LIN_CMD_M_RX,					// 呕uM(ڰѐ擪)+呕uM()
  LIN_CMD_S_RX,					// ]uM(ڰѐ擪+)
  LIN_CMD_S_TX,					// ]uM(ڰѐ擪)+]uM()
  LIN_CMD_SLP,					// x~(L)
  LIN_CMD_WUP					// N
} lin_cmd_t;

/**
* @brief ̗񋓂͑M̋NIɎgp܂B
**/
typedef enum {
  TX_EVENT,						// 
  TX_PERIODICALLY,				// I
  Tx_DELAY						// xt
} lin_trigger_t;

/**
* @brief ̗񋓂lin_getstatus̖߂lʂɎgp܂B
**/
typedef enum {
  LIN_AVAILABLE,					// p\Ԕԍ
  LIN_ACTION_COMPLETED,				// Ԕԍ
  LIN_ID_RECEIVED,					// ʎqMԔԍ
  LIN_ACTION_ONGOING,				// isԔԍ
  LIN_ERROR_BIT = 0xC1,				// ޯČԔԍ
  LIN_ERROR_CSUM = 0xC2,			// ьԔԍ
  LIN_ERROR_PARITY = 0xC4,			// èԔԍ
  LIN_ERROR_SYNCHRO = 0xC8,			// ُԔԍ
  LIN_ERROR_NO_ACTIVITY = 0xD0,		// ޽ȂԔԍ
  LIN_ERROR_NO_RESPONDING = 0xE0,	// ]uԔԍ
  LIN_SLEEP_MODE = 0xF0				// x~Ԕԍ
} lin_status_t;

/**
* @brief ̍\̂LINүޒ`܂B
**/
typedef  struct{
  U8 id;					// DLC܂ގʎq
  U8* pt_data;				// ްւ߲
} st_lin_t;

/**
* @brief ̍\̂LINԂł̎w芈`܂B
**/
typedef  struct{
  U8 handle;				// ߏ׸
  lin_cmd_t cmd;			// ߌ`
  st_lin_t* pt_lin_msg;		// үގeւ߲
} st_cmd_lin_t;


/*_____ ^錾 ____________________________________________________________*/
/**
* @fn lin_init
* @brief ̊֐LINK񏈗ɕKvȿĳ/ʰ޳ċ܂B
**/
U8 lin_init (void);

/**
* @fn lin_cmd
* @brief ̊֐LIN߉ߕłBsׂ͖ߍ\̂ɂė^
* ܂B
* @param pt_cmd
**/
U8 lin_cmd (st_cmd_lin_t* pt_cmd);

/**
* @fn lin_getstatus
* @brief ̊֐LIN̏ԂԂ܂B
* @return  lin_status
**/
lin_status_t lin_getstatus (st_cmd_lin_t* pt_cmd);

/**
* @fn nb_byte_to_lin_dlc
* @brief ̊֐DLCޯĂ޲Đɕϊ܂B
* @return number of bytes
**/
U8 nb_byte_to_lin_dlc(U8 dlc_trame);

/**
* @fn
* @brief
* @return
**/
U8 lin_dlc_to_nb_byte(U8 nb_byte);

/**
* @fn
* @brief
* @return
**/
U8 LIN_CalcChecksum (void);

/**
* @fn
* @brief
* @return
**/
U8 LIN_InitIdField(U8 lin_id ) ;

/**
* @fn
* @brief
* @return
**/
void Lin_hw_init(void);

#endif /* _LIN_LIB_H_ */

